package cpcns.dingZhi.impAndexpUtil.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.util.DataBaseUtil;
import cpcns.base.configuration.AppConfiguration;
import cpcns.common.service.ICommonService;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.impAndexpUtil.dao.ExpDao;
import cpcns.dingZhi.impAndexpUtil.service.ExpService;
import cpcns.gongyongzujian.dianzidangan.util.FuJianPathUtils;
import cpcns.jhsks.xinxifenlei.xitongmokuai.xitongpeizhidaima.model.XiTongDaiMa;
import cpcns.utils.CommStatic;
import cpcns.utils.ExportExcel;
import cpcns.utils.FileTool;
import cpcns.utils.FileUtil;
import cpcns.utils.FtpConfig;
import cpcns.utils.FtpUtil;
import cpcns.utils.OffLineUtil;
import cpcns.utils.ZipUtil;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.formula.functions.T;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.hibernate.SQLQuery;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

@Service("expService")
public class ExpServiceImpl extends DangAnBaseServiceImpl<T> implements ExpService {
  @Autowired
  private ExpDao expDao;
  
  @Autowired
  private ICommonService commonService;
  
  private Logger logger = LoggerFactory.getLogger(getClass());
  
  private String xiangmu = "*";
  
  private String anjuan = "*";
  
  private String wenjian = "*";
  
  private String fujian = "*";
  
  public String exportWenJian(String HBS, String table, String type, String guiDangNianDu, String baoGuanQiXian, String quanZhongHao, String guiDangNianDu_Operator, String leixing, String menlei, String yuanWen, String outType, HttpServletResponse response, String[] excelArray) {
    String zipName = "";
    StringBuffer hql = new StringBuffer();
    StringBuffer wjwhere = new StringBuffer();
    if ("MYSQL".equals(getDataType())) {
      this.wenjian = getTableColumnNames(table).toString().toUpperCase();
      this.wenjian = this.wenjian.substring(this.wenjian.indexOf("[") + 1, this.wenjian.lastIndexOf("]"));
      this.fujian = getTableColumnNames(String.valueOf(table) + "FuJian").toString().toUpperCase();
      this.fujian = this.fujian.substring(this.fujian.indexOf("[") + 1, this.fujian.lastIndexOf("]"));
    } 
    if (!this.wenjian.contains("GUANLIANBIAOSHI") && StringUtils.isNotBlank(menlei) && !"undefined".equals(menlei)) {
      hql.append("select ").append(this.wenjian).append(" from ").append(table).append(" where zhuangTai not in (3,4) and menLei ='" + menlei + "'");
    } else {
      hql.append("select ").append(this.wenjian).append(" from ").append(table).append(" where guanLianbiaoShi=0 and zhuangTai not in (3,4) ");
    } 
    if (StringUtils.isNotBlank(HBS)) {
      hql.append(" and hangBiaoShi in (" + HBS + ")");
      wjwhere.append(" and hangBiaoShi in (" + HBS + ")");
    } 
    if (StringUtils.isNotBlank(guiDangNianDu) && !"undefined".equals(guiDangNianDu))
      if ("=".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu = " + guiDangNianDu);
        wjwhere.append(" and guiDangNianDu = " + guiDangNianDu);
      } else if (">".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu > " + guiDangNianDu);
        wjwhere.append(" and guiDangNianDu > " + guiDangNianDu);
      } else if (">=".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu >= " + guiDangNianDu);
        wjwhere.append(" and guiDangNianDu >= " + guiDangNianDu);
      } else if ("<".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu < " + guiDangNianDu);
        wjwhere.append(" and guiDangNianDu < " + guiDangNianDu);
      } else if ("<=".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu <= " + guiDangNianDu);
        wjwhere.append(" and guiDangNianDu <= " + guiDangNianDu);
      } else if ("undefined".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu = " + guiDangNianDu);
        wjwhere.append(" and guiDangNianDu = " + guiDangNianDu);
      }  
    if (StringUtils.isNotBlank(leixing) && !"undefined".equals(leixing)) {
      hql.append(" and leiXing = '" + leixing + "'");
      wjwhere.append(" and leiXing = '" + leixing + "'");
    } 
    if (StringUtils.isNotBlank(baoGuanQiXian) && !"undefined".equals(baoGuanQiXian)) {
      hql.append(" and baoGuanQiXian = '" + baoGuanQiXian + "'");
      wjwhere.append(" and baoGuanQiXian = '" + baoGuanQiXian + "'");
    } 
    hql.append(" ORDER BY HANGBIAOSHI DESC");
    String wjsql = 
      String.format("select count(t.su) from (select HANGBIAOSHI as su from " + table + " where zhuangTai not in (3,4)  %s) t", new Object[] { wjwhere });
    int ajsum = this.expDao.getCountSql(wjsql);
    if (ajsum == 0)
      return "-1"; 
    String parent = AppConfiguration.getConfigValue("OACaiJiPath");
    String dirName = FileUtil.createRandomDirName();
    String dirPath = String.valueOf(parent) + File.separatorChar + type + dirName;
    String xmlPath = String.valueOf(dirPath) + File.separatorChar + type + dirName + ".xml";
    File offLineFile = new File(xmlPath);
    List<String> fuJianList = new ArrayList<>();
    Document document = DocumentHelper.createDocument();
    Element root = document.addElement("WENJIANS");
    List<Map<String, Object>> wenJianList = this.expDao.getListHqlpoge(hql.toString());
    if ("xml".equals(outType)) {
      File tempPath = new File(dirPath);
      if (!tempPath.exists())
        tempPath.mkdirs(); 
      try {
        for (Map<String, Object> wenjian : wenJianList) {
          Element wj = root.addElement("WENJIAN");
          setXml(wj, wenjian);
          if ("no".equals(yuanWen))
            continue; 
          if (this.expDao.fujian(wenjian.get("HANGBIAOSHI"), table)) {
            Element wenjianFuJian = wj.addElement("WENJIANFUJIANS");
            String hqlwj = "select " + this.fujian + " from " + table + "FuJian where 1 =1 ";
            hqlwj = String.valueOf(hqlwj) + " and guanLianBiaoShi =" + wenjian.get("HANGBIAOSHI");
            List<Map<String, Object>> wenjianfujianList = this.expDao.getListHqlpoge(hqlwj);
            for (Map<String, Object> fujian : wenjianfujianList) {
              Element fujianE = wenjianFuJian.addElement("WENJIANFUJIAN");
              setFuJianXml(fujianE, fujian, fuJianList);
              String target = "";
              String zptarget = "";
              if ("D_SHIWU".equals(table.toUpperCase()) || "D_YINXIANG".equals(table.toUpperCase())) {
                zptarget = String.valueOf(dirPath) + File.separatorChar + fujian.get("WENJIANCUNFANGLUJING").toString().replaceAll("·", "-");
                if (wenjian.get("MENLEI").equals("ZP") || wenjian.get("MENLEI").equals("SW")) {
                  target = String.valueOf(dirPath) + File.separatorChar + fujian.get("WENJIANCUNFANGLUJING") + "thumb/".replaceAll("·", "-");
                } else {
                  target = zptarget;
                } 
              } else {
                target = String.valueOf(dirPath) + File.separatorChar + fujian.get("CUNFANGLUJING").toString().replaceAll("·", "-");
              } 
              File f = new File(target);
              f.mkdirs();
              if ("1".equals(fujian.get("CHANGQIBAOCUNBIAOSHI"))) {
                if ("D_SHIWU".equals(table.toUpperCase()) || "D_YINXIANG".equals(table.toUpperCase())) {
                  if (wenjian.get("MENLEI").equals("ZP") || wenjian.get("MENLEI").equals("SW")) {
                    Boolean b = this.expDao.fileDownload(quanZhongHao, fujian.get("WENJIANCUNFANGLUJING").toString(), fujian.get("WENJIANMINGCHENG").toString().replaceAll("·", "-"), 
                        zptarget, fujian.get("YUANWENJIANMINGCHENG").toString());
                    String cflj = String.valueOf(fujian.get("WENJIANCUNFANGLUJING").toString()) + "thumb/".replaceAll("·", "-");
                    Boolean b2 = this.expDao.fileDownload(quanZhongHao, cflj, fujian.get("WENJIANMINGCHENG").toString().replaceAll("·", "-"), 
                        target, fujian.get("YUANWENJIANMINGCHENG").toString());
                    continue;
                  } 
                  Boolean bool = this.expDao.fileDownload(quanZhongHao, fujian.get("WENJIANCUNFANGLUJING").toString(), fujian.get("WENJIANMINGCHENG").toString().replaceAll("·", "-"), 
                      target, fujian.get("YUANWENJIANMINGCHENG").toString());
                  continue;
                } 
                if (StringUtils.isNotBlank(fujian.get("JISUANJIWENJIANMING").toString()))
                  Boolean bool = this.expDao.fileDownload(quanZhongHao, fujian.get("CUNFANGLUJING").toString(), 
                      fujian.get("JISUANJIWENJIANMING").toString().replaceAll("·", "-"), target, 
                      fujian.get("YUANWENJIANMING").toString()); 
                continue;
              } 
              if ("0".equals(fujian.get("CHANGQIBAOCUNBIAOSHI"))) {
                String oldpath = FuJianPathUtils.obtainCiPanPath(fujian.get("BEIYONGZIFU").toString());
                FileTool.copyFile(oldpath, String.valueOf(target) + fujian.get("YUANWENJIANMING"));
              } 
            } 
          } 
        } 
        OffLineUtil.createDoc(offLineFile, document);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      String zipPath = String.valueOf(parent) + "/temp/" + type + dirName + ".zip";
      zipName = String.valueOf(type) + dirName + ".zip";
      try {
        ZipUtil.packToolFiles(dirPath, zipPath);
        FileUtils.deleteDirectory(new File(dirPath));
      } catch (Exception e) {
        e.printStackTrace();
        this.logger.error("文件压缩异常");
        try {
          throw new IOException();
        } catch (IOException e1) {
          e1.printStackTrace();
        } 
      } 
    } else {
      zipName = getZipName(wenJianList, table, response, yuanWen, excelArray);
    } 
    return zipName;
  }
  
  private String getZipName(List<Map<String, Object>> wenJianList, String table, HttpServletResponse response, String yuanWen, String[] excelArray) {
    String zipName = "";
    String ywjm = "";
    String cflj = "";
    String jsjwjm = "";
    ArrayList<Map<String, Object>> newList = new ArrayList<>();
    ArrayList<String[]> excelTitle = (ArrayList)new ArrayList<>();
    if (excelArray.length == 0) {
      excelTitle.add(new String[] { "DANGHAO", "档号" });
      excelTitle.add(new String[] { "WENHAO", "文号" });
      excelTitle.add(new String[] { "ZERENZHE", "责任者" });
      excelTitle.add(new String[] { "BIAOTI", "题名" });
      excelTitle.add(new String[] { "CWRQ", "日期" });
      excelTitle.add(new String[] { "MIJI", "密级" });
      excelTitle.add(new String[] { "YESHU", "页数" });
      excelTitle.add(new String[] { "BEIZHU", "备注" });
      excelTitle.add(new String[] { "BEIZHU", "备注" });
    } else {
      List<String> PC = new ArrayList<>();
      for (int i = 0; i < excelArray.length; i++) {
        String[] mc = excelArray[i].split(";");
        String ywm = mc[0].toUpperCase();
        String zwm = mc[1];
        if (!PC.contains(ywm)) {
          PC.add(ywm);
          excelTitle.add(new String[] { ywm, zwm });
        } 
      } 
    } 
    String zipName1 = 
      String.valueOf((new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss")).format(new Date())) + "-" + getRandomName(Integer.valueOf(8));
    String filePath = String.valueOf(AppConfiguration.getConfigValue("DangAnYuanWenPath")) + 
      File.separator + "temp" + File.separator + zipName1;
    String fileName = 
      String.valueOf((new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss")).format(new Date())) + ".xlsx";
    String quanZongHao = this.expDao.getFtpQuanZong();
    FtpConfig ftpcfig = this.commonService.getFtpAccInfo(quanZongHao);
    Integer fjcount = Integer.valueOf(0);
    for (Iterator<Map<String, Object>> localIterator = wenJianList.iterator(); localIterator.hasNext(); ) {
      Map<String, Object> obj = localIterator.next();
      Object wjhbs = obj.get("HANGBIAOSHI");
      boolean isNotFjtable = this.expDao.fujian(wjhbs, table);
      if (isNotFjtable) {
        String hqlwj = "select " + this.fujian + " from " + table + 
          "FuJian where 1 =1 ";
        hqlwj = String.valueOf(hqlwj) + " and guanLianBiaoShi =" + wjhbs;
        List<Map<String, Object>> fjlist = this.expDao.getListHqlpoge(hqlwj);
        Integer size = Integer.valueOf(fjlist.size());
        int f = 0;
        for (Iterator<Map<String, Object>> fj = fjlist.iterator(); fj.hasNext(); ) {
          f++;
          Map<String, Object> fjobj = fj.next();
          if ("D_SHIWU".equals(table.toUpperCase()) || "D_YINXIANG".equals(table.toUpperCase())) {
            jsjwjm = (fjobj.get("WENJIANMINGCHENG") != null) ? fjobj
              .get("WENJIANMINGCHENG").toString() : "";
            ywjm = (fjobj.get("YUANWENJIANMINGCHENG") != null) ? fjobj.get(
                "YUANWENJIANMINGCHENG").toString() : "";
            cflj = (fjobj.get("WENJIANCUNFANGLUJING") != null) ? fjobj.get(
                "WENJIANCUNFANGLUJING").toString() : "";
          } else {
            jsjwjm = (fjobj.get("JISUANJIWENJIANMING") != null) ? fjobj
              .get("JISUANJIWENJIANMING").toString() : "";
            ywjm = (fjobj.get("YUANWENJIANMING") != null) ? fjobj.get(
                "YUANWENJIANMING").toString() : "";
            cflj = (fjobj.get("CUNFANGLUJING") != null) ? fjobj.get(
                "CUNFANGLUJING").toString() : "";
          } 
          String cqbcbs = (fjobj.get("CHANGQIBAOCUNBIAOSHI") != null) ? fjobj
            .get("CHANGQIBAOCUNBIAOSHI").toString() : "";
          if (fjcount.intValue() < size.intValue()) {
            fjcount = Integer.valueOf(fjcount.intValue() + 1);
            excelTitle.add(new String[] { "FUJIANPATH" + fjcount, 
                  "附件" + fjcount });
          } 
          String fjPath = String.valueOf(filePath) + File.separator + "excelDownload" + 
            File.separator + cflj;
          if ("yes".equals(yuanWen))
            if (cqbcbs.equals("1")) {
              FtpUtil ftp = new FtpUtil();
              jsjwjm = jsjwjm.replaceAll("·", "-");
              ftp.ftpDownload(ftpcfig, cflj, jsjwjm, fjPath, ywjm);
            } else {
              File file = new File(fjPath);
              if (!file.exists()) {
                file.setWritable(true);
                file.mkdirs();
              } 
              File myFile = new File(fjPath, ywjm);
              try {
                myFile.createNewFile();
              } catch (IOException e) {
                e.printStackTrace();
              } 
              String oldpath = FuJianPathUtils.obtainCiPanPath(String.valueOf(cflj) + 
                  ywjm);
              FileTool.copyFile(oldpath, String.valueOf(fjPath) + ywjm);
            }  
          cflj = cflj.replaceAll(" ", "");
          ywjm = ywjm.replaceAll(" ", "");
          obj.put("FUJIANPATH" + f, "excelDownload/" + cflj + ywjm);
        } 
      } 
      newList.add(obj);
    } 
    List<XiTongDaiMa> isbgqx = this.commonService.xiTongDaiMaList("11720");
    List<XiTongDaiMa> xtdms = this.commonService.xiTongDaiMaList("7087");
    List<XiTongDaiMa> bmqxs = this.commonService.xiTongDaiMaList("23867");
    String allout = "";
    String excelpath = ExportExcel.exportExcelAndDownload(response, null, 
        filePath, fileName, excelTitle, newList, isbgqx, xtdms, bmqxs, allout);
    if (StringUtils.isNotBlank(excelpath)) {
      String zipPath = String.valueOf(filePath) + ".zip";
      try {
        ZipUtil.packToolFiles(filePath, zipPath);
        FileUtils.deleteDirectory(new File(filePath));
        zipName = zipPath
          .substring(zipPath.lastIndexOf(File.separator) + 1);
      } catch (Exception e) {
        e.printStackTrace();
        System.out.println("xlsx文件生成成功，读取流下载出现问题！");
      } 
    } 
    return zipName;
  }
  
  private HttpServletRequest getRequest() {
    return ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
  }
  
  private byte[] findContentByte(String path, boolean type) {
    String cunChuPath = path;
    if (!type)
      cunChuPath = FuJianPathUtils.obtainCiPanPath(path); 
    File f = new File(cunChuPath);
    if (f.exists())
      try {
        InputStream in = new FileInputStream(f);
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        byte[] temp = new byte[1024];
        int size = 0;
        while ((size = in.read(temp)) != -1)
          out.write(temp, 0, size); 
        byte[] b = out.toByteArray();
        out.close();
        in.close();
        return b;
      } catch (IOException e) {
        e.printStackTrace();
        return null;
      }  
    return null;
  }
  
  private String getRandomName(Integer length) {
    String str = "";
    Random ran = new Random();
    for (int i = 0; i < length.intValue(); i++) {
      boolean b = ran.nextBoolean();
      if (b) {
        str = String.valueOf(str) + (char)(65 + ran.nextInt(26));
      } else {
        str = String.valueOf(str) + String.valueOf(ran.nextInt(10));
      } 
    } 
    return str;
  }
  
  private void setFuJianXml(Element fujianE, Map<String, Object> fujian, List<String> fuJianList) {
    for (Map.Entry<String, Object> entry : fujian.entrySet()) {
      if (!"".equals(entry.getValue()) && entry.getValue() != null)
        fujianE.addElement(entry.getKey()).setText(entry.getValue().toString()); 
    } 
  }
  
  private void setXml(Element wenjianE, Map<String, Object> wenjian) {
    for (Map.Entry<String, Object> entry : wenjian.entrySet()) {
      if (!"".equals(entry.getValue()) && entry.getValue() != null)
        wenjianE.addElement(entry.getKey()).setText(entry.getValue().toString()); 
    } 
  }
  
  public String exportAnJuan(String HBS, String table, String type, String guiDangNianDu, String baoGuanQiXian, String quanZhongHao, String guiDangNianDu_Operator, String yuanWen, String outType, HttpServletResponse response, String menlei, String[] excelArray) {
    StringBuffer hql = new StringBuffer();
    StringBuffer ajwhere = new StringBuffer();
    StringBuffer wjwhere = new StringBuffer();
    if ("MYSQL".equals(getDataType())) {
      this.anjuan = getTableColumnNames(table).toString().toUpperCase();
      this.anjuan = this.anjuan.substring(this.anjuan.indexOf("[") + 1, this.anjuan.lastIndexOf("]"));
    } 
    hql.append("select ").append(this.anjuan).append(" from ").append(table).append(" where zhuangTai not in (3,4) ");
    if (StringUtils.isNotBlank(HBS)) {
      hql.append(" and hangBiaoShi in (" + HBS + ")");
      ajwhere.append(" and hangBiaoShi in (" + HBS + ")");
      wjwhere.append(" and d.hangBiaoShi in (" + HBS + ")");
    } 
    if (StringUtils.isNotBlank(guiDangNianDu) && !"undefined".equals(guiDangNianDu))
      if ("=".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu = " + guiDangNianDu);
        ajwhere.append(" and guiDangNianDu = " + guiDangNianDu);
        wjwhere.append(" and d.guiDangNianDu = " + guiDangNianDu);
      } else if (">".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu > " + guiDangNianDu);
        ajwhere.append(" and guiDangNianDu > " + guiDangNianDu);
        wjwhere.append(" and d.guiDangNianDu > " + guiDangNianDu);
      } else if (">=".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu >= " + guiDangNianDu);
        ajwhere.append(" and guiDangNianDu >= " + guiDangNianDu);
        wjwhere.append(" and d.guiDangNianDu >= " + guiDangNianDu);
      } else if ("<".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu < " + guiDangNianDu);
        ajwhere.append(" and guiDangNianDu < " + guiDangNianDu);
        wjwhere.append(" and d.guiDangNianDu < " + guiDangNianDu);
      } else if ("<=".equals(guiDangNianDu_Operator)) {
        hql.append(" and guiDangNianDu <= " + guiDangNianDu);
        ajwhere.append(" and guiDangNianDu <= " + guiDangNianDu);
        wjwhere.append(" and d.guiDangNianDu <= " + guiDangNianDu);
      }  
    if (StringUtils.isNotBlank(baoGuanQiXian) && !"undefined".equals(guiDangNianDu) && !"undefined".equals(baoGuanQiXian)) {
      hql.append(" and baoGuanQiXian = '" + baoGuanQiXian + "'");
      ajwhere.append(" and baoGuanQiXian = '" + baoGuanQiXian + "'");
      wjwhere.append(" and d.baoGuanQiXian = '" + baoGuanQiXian + "'");
    } 
    if (StringUtils.isNotBlank(menlei) && !"undefined".equals(menlei)) {
      hql.append(" and menlei = '" + menlei + "'");
      ajwhere.append(" and menlei = '" + menlei + "'");
      wjwhere.append(" and d.menlei = '" + menlei + "'");
    } 
    hql.append(" ORDER BY HANGBIAOSHI DESC");
    wjwhere.append(" ORDER BY d.HANGBIAOSHI DESC");
    String ajsql = String.format("select count(t.su) from (select HANGBIAOSHI as su from " + table + " where zhuangTai not in (3,4)  %s) t", new Object[] { ajwhere });
    int ajsum = this.expDao.getCountSql(ajsql);
    if (ajsum == 0)
      return "-1"; 
    String wjtable = "";
    wjtable = table.toLowerCase().replace("anjuan", "");
    if (StringUtils.isNoneBlank(new CharSequence[] { table }) && table.toUpperCase().equals("D_ZHUANYEANJUAN"))
      wjtable = table.replace("anjuan", "wenJian"); 
    String wjsql = String.format("select COUNT(1) from " + wjtable + " w ," + table + " a where w.GUANLIANBIAOSHI=a.HANGBIAOSHI and a.HANGBIAOSHI in(SELECT j.HANGBIAOSHI FROM( select d.HANGBIAOSHI from " + table + " d where d.zhuangTai not in (3,4) %s)j)", new Object[] { wjwhere });
    int wjsum = this.expDao.getCountSql(wjsql);
    String parent = AppConfiguration.getConfigValue("OACaiJiPath");
    String dirName = FileUtil.createRandomDirName();
    String dirPath = String.valueOf(parent) + "/" + type + dirName;
    File tempPath = new File(dirPath);
    if (!tempPath.exists())
      tempPath.mkdirs(); 
    String xmlPath = String.valueOf(dirPath) + "/" + type + dirName + ".xml";
    File offLineFile = new File(xmlPath);
    List<String> fuJianList = new ArrayList<>();
    try {
      Document document = DocumentHelper.createDocument();
      Element root = document.addElement("ANJUANS");
      List<Map<String, Object>> anJuanList = this.expDao.getListHqlpoge(hql.toString());
      List<Map<String, Object>> listall = new ArrayList<>();
      for (Map<String, Object> aj : anJuanList) {
        Element daj = root.addElement("ANJUAN");
        setXml(daj, aj);
        if ("excel".equals(outType)) {
          StringBuffer hql1 = new StringBuffer();
          if ("MYSQL".equals(getDataType())) {
            this.wenjian = getTableColumnNames(wjtable).toString().toUpperCase();
            this.fujian = getTableColumnNames(String.valueOf(wjtable) + "FuJian ").toString().toUpperCase();
            this.wenjian = this.wenjian.substring(this.wenjian.indexOf("[") + 1, this.wenjian.lastIndexOf("]"));
            this.fujian = this.fujian.substring(this.fujian.indexOf("[") + 1, this.fujian.lastIndexOf("]"));
          } 
          hql1.append("select ").append(this.wenjian).append(" from ").append(wjtable);
          hql1 = hql1.append(" where guanLianBiaoShi =" + aj.get("HANGBIAOSHI"));
          List<Map<String, Object>> wenjianList = this.expDao.getListHqlpoge(hql1.toString());
          listall.addAll(wenjianList);
          continue;
        } 
        createWenJianNode(daj, aj, fuJianList, dirPath, quanZhongHao, wjtable, yuanWen);
      } 
      if ("excel".equals(outType))
        return getZipName(listall, wjtable, response, yuanWen, excelArray); 
      OffLineUtil.createDoc(offLineFile, document);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    String zipPath = String.valueOf(parent) + "/temp/" + type + dirName + ".zip";
    String zipName = String.valueOf(type) + dirName + ".zip";
    try {
      ZipUtil.packToolFiles(dirPath, zipPath);
      FileUtils.deleteDirectory(new File(dirPath));
    } catch (Exception e) {
      e.printStackTrace();
      this.logger.error("文件压缩异常");
    } 
    return zipName;
  }
  
  private boolean createWenJianNode(Element danganhe, Map<String, Object> aj, List<String> fuJianList, String dirPath, String quanZhongHao, String wjtable, String yuanWen) {
    StringBuffer hql = new StringBuffer();
    Element wenjians = danganhe.addElement("WENJIANS");
    if ("MYSQL".equals(getDataType())) {
      this.wenjian = getTableColumnNames(wjtable).toString().toUpperCase();
      this.fujian = getTableColumnNames(String.valueOf(wjtable) + "FuJian ").toString().toUpperCase();
      this.wenjian = this.wenjian.substring(this.wenjian.indexOf("[") + 1, this.wenjian.lastIndexOf("]"));
      this.fujian = this.fujian.substring(this.fujian.indexOf("[") + 1, this.fujian.lastIndexOf("]"));
    } 
    hql.append("select ").append(this.wenjian).append(" from ").append(wjtable);
    hql = hql.append(" where guanLianBiaoShi =" + aj.get("HANGBIAOSHI"));
    List<Map<String, Object>> wenjianList = this.expDao.getListHqlpoge(hql.toString());
    Boolean fjtype = Boolean.valueOf(true);
    String table = wjtable.toUpperCase();
    if ("MYSQL".equals(getDataType())) {
      try {
        String sql1 = "SELECT 1 FROM " + wjtable + "fujian LIMIT 1";
        this.expDao.getSession().createSQLQuery(sql1).list();
      } catch (Exception e) {
        System.out.println("现在是mysql 数据库！系统判定你现在连接的数据库没有" + wjtable + "fujian 表。");
        fjtype = Boolean.valueOf(false);
      } 
    } else {
      String isnotTable = "SELECT COUNT(*) FROM user_tables WHERE table_name = '" + table + "FUJIAN'";
      SQLQuery query = this.expDao.getSession().createSQLQuery(isnotTable);
      List<String> list = query.list();
      if ("0".equals(query.list().get(0).toString())) {
        System.out.println("现在是oracle 数据库！系统判定你现在连接的数据库没有" + table + "fujian 表。");
        fjtype = Boolean.valueOf(false);
      } 
    } 
    for (Map<String, Object> wenjian : wenjianList) {
      StringBuffer fujiansql = new StringBuffer();
      Element wj = wenjians.addElement("WENJIAN");
      setXml(wj, wenjian);
      fujiansql.append("select ").append(this.fujian).append(" from " + wjtable + "FuJian where 1 =1 ");
      fujiansql.append(" and guanLianBiaoShi =" + wenjian.get("HANGBIAOSHI"));
      if (!fjtype.booleanValue())
        continue; 
      List<Map<String, Object>> wenjianfujianList = this.expDao.getListHqlpoge(fujiansql.toString());
      if (wenjianfujianList != null && wenjianfujianList.size() != 0) {
        Element wjfj = wj.addElement("WENJIANFUJIANS");
        for (Map<String, Object> fujian : wenjianfujianList) {
          Element fujianE = wjfj.addElement("WENJIANFUJIAN");
          setFuJianXml(fujianE, fujian, fuJianList);
          if ("no".equals(yuanWen))
            continue; 
          String target = String.valueOf(dirPath) + File.separatorChar + fujian.get("CUNFANGLUJING");
          File f = new File(target);
          f.mkdirs();
          if ("1".equals(fujian.get("CHANGQIBAOCUNBIAOSHI"))) {
            if (StringUtils.isNotBlank(fujian.get("JISUANJIWENJIANMING").toString()))
              Boolean bool = this.expDao.fileDownload(quanZhongHao, fujian.get("CUNFANGLUJING").toString(), 
                  fujian.get("JISUANJIWENJIANMING").toString(), target, 
                  fujian.get("YUANWENJIANMING").toString()); 
            continue;
          } 
          if ("0".equals(fujian.get("CHANGQIBAOCUNBIAOSHI"))) {
            String oldpath = FuJianPathUtils.obtainCiPanPath(fujian.get("BEIYONGZIFU").toString());
            FileTool.copyFile(oldpath, String.valueOf(target) + fujian.get("YUANWENJIANMING"));
          } 
        } 
        continue;
      } 
      System.out.println((new StringBuilder()).append(wenjian.get("HANGBIAOSHI")).append("文件的附件为空！！").toString());
    } 
    return false;
  }
  
  public String exportXM(String HBS, String table, String type, String quanZhongHao, String yuanWen, String outType, HttpServletResponse response, String[] excelArray) {
    StringBuffer hql = new StringBuffer();
    StringBuffer ajwhere = new StringBuffer();
    StringBuffer wjwhere = new StringBuffer();
    if ("MYSQL".equals(getDataType())) {
      this.xiangmu = getTableColumnNames(table).toString().toUpperCase();
      this.anjuan = getTableColumnNames(table.toLowerCase().replace("xiangmu", "anjuan")).toString().toUpperCase();
      this.xiangmu = this.xiangmu.substring(this.xiangmu.indexOf("[") + 1, this.xiangmu.lastIndexOf("]"));
      this.anjuan = this.anjuan.substring(this.anjuan.indexOf("[") + 1, this.anjuan.lastIndexOf("]"));
    } 
    hql.append("select ").append(this.xiangmu).append(" from " + table + " where zhuangTai not in (3,4)");
    if (StringUtils.isNotBlank(HBS)) {
      hql.append(" and hangBiaoShi in (" + HBS + ")");
      ajwhere.append(" and hangBiaoShi in (" + HBS + ")");
      wjwhere.append(" and d.hangBiaoShi in (" + HBS + ")");
    } 
    hql.append(" ORDER BY HANGBIAOSHI DESC");
    wjwhere.append(" ORDER BY d.HANGBIAOSHI DESC");
    String ajsql = String.format("select count(t.su) from (select HANGBIAOSHI as su from " + table + " where zhuangTai not in (3,4)  %s) t", new Object[] { ajwhere });
    int ajsum = this.expDao.getCountSql(ajsql);
    if (ajsum == 0)
      return "-1"; 
    String parent = AppConfiguration.getConfigValue("OACaiJiPath");
    String dirName = FileUtil.createRandomDirName();
    String dirPath = String.valueOf(parent) + "/" + type + dirName;
    File tempPath = new File(dirPath);
    if (!tempPath.exists())
      tempPath.mkdirs(); 
    String xmlPath = String.valueOf(dirPath) + "/" + type + dirName + ".xml";
    File offLineFile = new File(xmlPath);
    List<String> fuJianList = new ArrayList<>();
    try {
      Document document = DocumentHelper.createDocument();
      Element root = document.addElement("XIANGMUS");
      List<Map<String, Object>> XMList = this.expDao.getListHqlpoge(hql.toString());
      List<Map<String, Object>> listall = new ArrayList<>();
      String ajsql2 = "";
      String ajtable = table.toLowerCase().replace("xiangmu", "anjuan");
      String wjtable = table.toLowerCase().replace("xiangmu", "");
      for (Map<String, Object> xm : XMList) {
        Element daj = root.addElement("XIANGMU");
        setXml(daj, xm);
        ajsql2 = "select " + this.anjuan + " from " + ajtable + " where zhuangTai not in (3,4) and guanLianBiaoShi=" + xm.get("HANGBIAOSHI");
        List<Map<String, Object>> ajList = this.expDao.getListHqlpoge(ajsql2.toString());
        Element daj2 = daj.addElement("ANJUANS");
        for (Map<String, Object> aj : ajList) {
          Element daj3 = daj2.addElement("ANJUAN");
          setXml(daj3, aj);
          if ("excel".equals(outType)) {
            StringBuffer hql1 = new StringBuffer();
            if ("MYSQL".equals(getDataType())) {
              this.wenjian = getTableColumnNames(wjtable).toString().toUpperCase();
              this.fujian = getTableColumnNames(String.valueOf(wjtable) + "FuJian ").toString().toUpperCase();
              this.wenjian = this.wenjian.substring(this.wenjian.indexOf("[") + 1, this.wenjian.lastIndexOf("]"));
              this.fujian = this.fujian.substring(this.fujian.indexOf("[") + 1, this.fujian.lastIndexOf("]"));
            } 
            hql1.append("select ").append(this.wenjian).append(" from ").append(wjtable);
            hql1 = hql1.append(" where guanLianBiaoShi =" + aj.get("HANGBIAOSHI"));
            List<Map<String, Object>> wenjianList = this.expDao.getListHqlpoge(hql1.toString());
            listall.addAll(wenjianList);
            continue;
          } 
          createWenJianNode(daj3, aj, fuJianList, dirPath, quanZhongHao, wjtable, yuanWen);
        } 
      } 
      if ("excel".equals(outType))
        return getZipName(listall, wjtable, response, yuanWen, excelArray); 
      OffLineUtil.createDoc(offLineFile, document);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    String zipPath = String.valueOf(parent) + "/temp/" + type + dirName + ".zip";
    String zipName = String.valueOf(type) + dirName + ".zip";
    try {
      ZipUtil.packToolFiles(dirPath, zipPath);
      FileUtils.deleteDirectory(new File(dirPath));
    } catch (Exception e) {
      e.printStackTrace();
      this.logger.error("文件压缩异常");
    } 
    return zipName;
  }
  
  public List<String> getTableColumnNames(String tableName) {
    List<String> columnNames = new ArrayList<>();
    String DBDRIVER = "";
    String IP = "";
    String user = "";
    String mima = "";
    List<Object[]> list = this.expDao.getList("select databaseurl,databasedriver,yonghumingcheng,yonghumima from s_manage where hangBiaoShi=4");
    if (list != null && list.size() > 0) {
      Object[] objects = list.get(0);
      IP = objects[0].toString();
      DBDRIVER = objects[1].toString();
      user = objects[2].toString();
      mima = objects[3].toString();
    } 
    IP = getXiTongDaiMaByMingCheng("23219", 2, IP);
    DBDRIVER = getXiTongDaiMaByMingCheng("23215", 2, DBDRIVER);
    String dataType = DataBaseUtil.getCurSessionDBType(this.expDao.getSession());
    Connection conn = CommStatic.getConnection_(DBDRIVER, IP, user, mima);
    PreparedStatement pStemt = null;
    String SQL = "SELECT * FROM ";
    String tableSql = String.valueOf(SQL) + tableName;
    try {
      pStemt = conn.prepareStatement(tableSql);
      ResultSetMetaData rsmd = pStemt.getMetaData();
      int size = rsmd.getColumnCount();
      for (int i = 0; i < size; i++)
        columnNames.add(rsmd.getColumnName(i + 1)); 
    } catch (SQLException e) {
      e.printStackTrace();
    } finally {
      if (pStemt != null)
        try {
          pStemt.close();
          conn.close();
        } catch (SQLException e) {
          e.printStackTrace();
        }  
    } 
    return columnNames;
  }
}
